<template>

	<div class="flex" v-if="options.length">
		<label for="sorter" class="mr-2 p-1 hidden sm:block">Sort by:</label>
		<select id="sorter" class="border rounded p-1" v-model="currentValue">
			<option v-for="option in options" :value="option" :key="option">{{ option.name }}</option>
		</select>
	</div>

</template>

<script>

/**
 * @typedef {object} SortOption
 * @property {string} name The name that gets displayed to the user for this option
 * @property {string} field The field of the item to be used when sorting with this option
 * @property {-1|1} direction The direction of the sort: 1 for ascending, -1 for descending
 */ 

/**
 * Basic dropdown component to display a list of options to use in sorting a given set of items (out of scope).
 * Will emit a sortChanged event with a value of the same type on user interaction.
 */
export default {
	props: {
		/**
		 * The options to display to the user.
		 * @type SortOption[]
		 */
		options: Array,

		/**
		 * The current sort applied.
		 * @type SortOption
		 */
		modelValue: Object
	},
	emits: [
		'update:modelValue'
	],
	computed: {
		currentValue: {
			get() {
				return this.modelValue;
			},
			set(value) {
				this.$emit( 'update:modelValue', value );
			}
		}
	}
}
</script>
